VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Movie"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const delim As String * 1 = "|"

Private m_sIndex As String
Private m_sTitle As String
Private m_lDiscs As Long
Private m_lSize As Long
Private m_lTime As Long
Private m_lWidth As Long
Private m_lHeight As Long
Private m_lYear As Long
Private m_CD As Boolean
Private m_HD As Boolean
Private m_lIMDB As Long
Private m_sVideoCodec As String
Private m_lVBR As Long
Private m_sAudioCodec As String
Private m_lABR As Long

Public Enum mvColumn
  mvcTitle = 0
  mvcDiscs = 1
  mvcSize = 2
  mvcTime = 4
  mvcResolution = 8
  mvcYear = 16
  mvcCD = 32
  mvcHD = 64
  mvcVideoCodec = 128
  mvcAudioCodec = 256
  mvcVBR = 512
  mvcABR = 1024
End Enum


Public Property Get Index() As String
  If Len(m_sIndex) > 0 Then
    Index = m_sIndex
  Else
    Index = formIndex(Title)
  End If
End Property

Public Property Get Title() As String
  Title = m_sTitle
End Property

Public Property Get Discs() As Long
  Discs = m_lDiscs
End Property

Public Property Get Size() As Long
  Size = m_lSize
End Property

Public Property Get Time() As Long
  Time = m_lTime
End Property

Public Property Get Width() As Long
  Width = m_lWidth
End Property

Public Property Get Height() As Long
  Height = m_lHeight
End Property

Public Property Get Year() As Long
  Year = m_lYear
End Property

Public Property Get CD() As Boolean
  CD = m_CD
End Property

Public Property Get HD() As Boolean
  HD = m_HD
End Property

Public Property Get IMDB() As Long
  IMDB = m_lIMDB
End Property

Public Property Get IMDBurl() As String
  If m_lIMDB > 0 Then IMDBurl = "http://us.imdb.com/Title?" & Format$(m_lIMDB, "0000000")
End Property

Public Property Get VideoCodec() As String
  VideoCodec = m_sVideoCodec
End Property

Public Property Get VBR() As Long
  VBR = m_lVBR
End Property

Public Property Get AudioCodec() As String
  AudioCodec = m_sAudioCodec
End Property

Public Property Get ABR() As Long
  ABR = m_lABR
End Property

Private Property Let Index(ByVal i As String)
  m_sIndex = i
End Property

Private Property Let Title(ByVal t As String)
  m_sTitle = t
End Property

Private Property Let Discs(ByVal d As Long)
  m_lDiscs = d
End Property

Private Property Let Size(ByVal s As Long)
  m_lSize = s
End Property

Private Property Let Time(ByVal t As Long)
  m_lTime = t
End Property

Private Property Let Width(ByVal w As Long)
  m_lWidth = w
End Property

Private Property Let Height(ByVal h As Long)
  m_lHeight = h
End Property

Private Property Let Year(ByVal y As Long)
  m_lYear = y
End Property

Private Property Let CD(ByVal c As Boolean)
  m_CD = c
End Property

Private Property Let HD(ByVal h As Boolean)
  m_HD = h
End Property

Private Property Let IMDB(ByVal i As Long)
  m_lIMDB = i
End Property

Private Property Let VideoCodec(ByVal v As String)
  m_sVideoCodec = v
End Property

Private Property Let VBR(ByVal v As Long)
  m_lVBR = v
End Property

Private Property Let AudioCodec(ByVal a As String)
  m_sAudioCodec = a
End Property

Private Property Let ABR(ByVal a As Long)
  m_lABR = a
End Property

Public Sub SetUp(ByVal newTitle As String, ByVal newDiscs As Long, _
                 ByVal newSize As Long, ByVal newTime As Long, _
                 ByVal newWidth As Long, ByVal newHeight As Long, _
                 ByVal newYear As Long, ByVal newCD As Boolean, _
                 ByVal newHD As Boolean, ByVal newIMDB As Long, _
                 ByVal newVideoCodec As String, ByVal newVBR As Long, _
                 ByVal newAudioCodec As String, ByVal newABR As Long, _
                 Optional ByVal newIndex As String = "")
  Index = newIndex
  Title = newTitle
  Discs = newDiscs
  Size = newSize
  Time = newTime
  Width = newWidth
  Height = newHeight
  Year = newYear
  CD = newCD
  HD = newHD
  IMDB = newIMDB
  VideoCodec = newVideoCodec
  VBR = newVBR
  AudioCodec = newAudioCodec
  ABR = newABR
End Sub

Friend Function toString() As String
  toString = Index & delim & _
           Title & delim & _
           Discs & delim & _
           Size & (delim & _
           Time & delim & _
           Width & delim & _
           Height & delim & _
           Year & delim & _
           CD & delim & _
           HD & delim) & _
           m_lIMDB & delim & _
           VideoCodec & delim & _
           VBR & delim & _
           AudioCodec & delim & _
           ABR
End Function

Friend Function HTML(columns As mvColumn)
  If IMDB > 0 Then
    HTML = "        <tr>" & vbCrLf & _
           "          <td><a href=""" & IMDBurl & """ title=""find out more at IMDb""><span>" & Title & "</span></td>"
  Else
    HTML = "        <tr>" & vbCrLf & _
           "          <td>" & Title & "</td>"
  End If
  If (columns And mvcDiscs) = mvcDiscs Then HTML = HTML & vbCrLf & "          <td>" & Format$(Discs, "#") & "</td>"
  If (columns And mvcSize) = mvcSize Then HTML = HTML & vbCrLf & "          <td>" & Format$(Size, "#,###") & "</td>"
  If (columns And mvcTime) = mvcTime Then HTML = HTML & vbCrLf & "          <td>" & fmtTime$ & "</td>"
  If (columns And mvcResolution) = mvcResolution Then HTML = HTML & vbCrLf & "          <td>" & fmtRes$ & "</td>"
  If (columns And mvcYear) = mvcYear Then HTML = HTML & vbCrLf & "          <td>" & Format$(Year, "#") & "</td>"
  If (columns And mvcCD) = mvcCD Then
    If CD Then
      HTML = HTML & vbCrLf & "          <td>yes</td>"
    Else
      HTML = HTML & vbCrLf & "          <td>no</td>"
    End If
  End If
  If (columns And mvcHD) = mvcHD Then
    If HD Then
      HTML = HTML & vbCrLf & "          <td>yes</td>"
    Else
      HTML = HTML & vbCrLf & "          <td>no</td>"
    End If
  End If
  If (columns And mvcVideoCodec) = mvcVideoCodec Then HTML = HTML & vbCrLf & "          <td>" & VideoCodec & "</td>"
  If (columns And mvcVBR) = mvcVBR Then HTML = HTML & vbCrLf & "          <td>" & Format$(VBR, "#") & "</td>"
  If (columns And mvcAudioCodec) = mvcAudioCodec Then HTML = HTML & vbCrLf & "          <td>" & AudioCodec & "</td>"
  If (columns And mvcABR) = mvcABR Then HTML = HTML & vbCrLf & "          <td>" & Format$(ABR, "#") & "</td>"
  HTML = HTML & vbCrLf & "        </tr>"
End Function

Private Function fmtTime$()
  If Time > 0 Then
    fmtTime$ = Format$(Time, "0:00:00")
  Else
    fmtTime$ = ""
  End If
End Function

Private Function fmtRes$()
  If Width > 0 Then
    fmtRes$ = Width & "x" & Height
  Else
    fmtRes$ = ""
  End If
End Function

Friend Sub readFileData(data As String)
  Dim d1 As Long, d2 As Long
  d1 = 1
  d2 = InStr(1, data, delim)
  Index = Mid$(data, d1, d2 - d1)
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Title = Mid$(data, d1, d2 - d1)
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Discs = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Size = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Time = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Width = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Height = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  Year = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  CD = CBool(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  HD = CBool(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  IMDB = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  VideoCodec = Mid$(data, d1, d2 - d1)
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  VBR = CLng(Mid$(data, d1, d2 - d1))
  d1 = d2 + 1
  d2 = InStr(d1, data, delim)
  AudioCodec = Mid$(data, d1, d2 - d1)
  d1 = d2 + 1
  ABR = CLng(Mid$(data, d1))
End Sub

Private Function formIndex(ByVal base As String)
  If LCase$(Left$(base, 4)) = "the " Then
    base = Right$(base, Len(base) - 4)
  ElseIf LCase$(Left$(base, 2)) = "a " Then
    base = Right$(base, Len(base) - 2)
  End If
  formIndex = base
End Function
